.\"
.\" Copyright (c) 2000 Alfred Perlstein
.\"
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE DEVELOPERS ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE DEVELOPERS BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\" NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\" THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\" (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\" THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.\" $FreeBSD: src/share/man/man9/accf_data.9,v 1.8 2005/01/18 20:52:51 ru Exp $
.\" "
.Dd August 10, 2008
.Dt ACCF_DATA 9
.Os
.Sh NAME
.Nm accf_data
.Nd buffer incoming connections until data arrives
.Sh SYNOPSIS
.Cd "options INET"
.Cd "pseudo-device accf_data"
.Sh DESCRIPTION
This is a filter to be placed on a socket that will be using
.Fn accept
to receive incoming connections.
.Pp
It prevents the application from receiving the connected descriptor via
.Fn accept
until data arrives on the connection.
.Sh EXAMPLES
If the accf_data accept filter is present in the kernel configuration,
this will enable the data accept filter
on the socket
.Fa sok .
.Bd -literal -offset 0i
	struct accept_filter_arg afa;

	bzero(&afa, sizeof(afa));
	strcpy(afa.af_name, "dataready");
	setsockopt(sok, SOL_SOCKET, SO_ACCEPTFILTER, &afa, sizeof(afa));
.Ed
.Sh SEE ALSO
.Xr setsockopt 2 ,
.Xr accept_filter 9 ,
.Xr accf_http 9
.Sh HISTORY
The accept filter mechanism and the
accf_data filter were introduced in
.Fx 4.0 .
They were ported to
.Nx
by Coyote Point Systems and appeared in
.Nx 5.0 .
.Sh AUTHORS
This manual page and the filter were written by
.An Alfred Perlstein .
